/**************************************************************************************

Copyright (c) Hilscher Gesellschaft fuer Systemautomation mbH. All Rights Reserved.

***************************************************************************************

  $Id: ResetDlg.h 14181 2021-08-12 08:34:06Z LContreras $:

  Description:
    Device Reset Dialog

  Changes:
    Date        Description
    -----------------------------------------------------------------------------------
    2006-07-05  initial version

**************************************************************************************/

///////////////////////////////////////////////////////////////////////////////////////////
/// \file ResetDlg.h
///   Device Reset Dialog
///////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "hexedit.h"
#include "BaseDialog.h"
#include "afxwin.h"

///////////////////////////////////////////////////////////////////////////////////////////
/// Device Reset Dialog
///////////////////////////////////////////////////////////////////////////////////////////
class CResetDlg : public CBaseDialog
{
	DECLARE_DYNAMIC(CResetDlg)

public:
	CResetDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CResetDlg();

  void ThreadFunction(void);
  void OnUpdateDevice(CCifXDeviceBase* pcDevice);

// Dialog Data
	enum { IDD = IDD_RESET };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

  unsigned long   m_ulTimeout;      //!< Timeout for reset
  unsigned long   m_ulResetMode;    //!< Mode to pass to reset command
  unsigned long   m_ulResetParam;   //!< Extended Mode (Parameter) to pass to reset command

  CComboBox       m_cResetModeCtrl; //!< Reset mode combobox control

  CButton         m_cResetExDeleteRemanentCtrl; //!< Checkbox: Delete Remanent Data
  CButton         m_cResetExVerifyCtrl; //!< Checkbox: Verify firmware installation

  // State variables for Checkboxes
  bool            m_fResetExDeleteRemanent;
  bool            m_fResetExVerify;

	DECLARE_MESSAGE_MAP()
public:
  virtual BOOL OnInitDialog();
  afx_msg void OnCbnSelchangeCbReset();
  afx_msg void OnEnKillfocusEdtTimeout();
  afx_msg void OnEnKillfocusEdtParam();
  afx_msg void OnBnClickedBtnReset();
};
